# Author:: Gerhard Spitzlsperger
# EMAIL and WWW:: ruby@gs68.de, www.gs68.de
# Copyright:: Copyright (c) 2003 Gerhard Spitzlsperger. All rights reserved.
# License:: LGPL see file LICENSE.
# Version 0.1

require 'fox'
require 'fox/colors'

include Fox

class GS_Style
  attr_accessor   :backColour
  attr_accessor   :foreColour
  attr_accessor   :fontName
  attr_accessor   :fontSize
  attr_accessor   :lineStyle
  attr_accessor   :lineWidth
  attr_accessor   :dashPattern
  attr_accessor   :dashOffset  
  attr_accessor   :fillStyle
    
  attr_accessor   :defaultBackColour
  attr_accessor   :defaultForeColour
  attr_accessor   :defaultFontName
  attr_accessor   :defaultFontSize
  attr_accessor   :defaultLineStyle
  attr_accessor   :defaultLineWidth
  attr_accessor   :defaultDashPattern
  attr_accessor   :defaultDashOffset
  attr_accessor   :defaultFillStyle   
    
  def initialize
    init
    reset
  end   
    
  def reset
    @backColour = @defaultBackColour
    @foreColour = @defaultForeColour
    @fontName = @defaultFontName
    @fontSize = @defaultFontSize
    @lineStyle = @defaultLineStyle
    @lineWidth = @defaultLineWidth
    @dashPattern = @defaultDashPattern
    @dashOffset = @defaultDashOffset 
    @fillStyle = @defaultFillStyle 
  end
  
  def init
    @defaultBackColour = FXColor::White
    @defaultForeColour = FXColor::Black
    @defaultFontName = "courier"
    @defaultFontSize = 11
    @defaultLineStyle = LINE_SOLID
    @defaultLineWidth = 1
    @defaultDashPattern = [8, 8]
    @defaultDashOffset = 50
    @defaultFillStyle = FILL_SOLID
  end 
  
  def adjustDC(dc)
    dc.foreground = @foreColour
    dc.background = @backColour
    
    @textFont = FXFont.new(dc.getApp(), @fontName, @fontSize)
    @textFont.create
    
    dc.textFont = @textFont
    dc.lineStyle = @lineStyle
    dc.lineWidth = @lineWidth
    dc.fillStyle = @fillStyle
    dc.setDashes(@dashOffset, @dashPattern)
  end  
end

